﻿using MauiAppStock.Models;
using MauiAppStock.Data;

namespace MauiAppStock.Views
{
    public partial class EditPiecePage : ContentPage
    {
        private Piece _piece;
        
        public EditPiecePage(Piece piece)
        {
            InitializeComponent();
            // LoadAppareils();
            _piece = piece;
            NomEntry.Text = piece.Nom;
            DescriptionEditor.Text = piece.Description;
            PrixEntry.Text = piece.Prix.ToString();
            StockEntry.Text = piece.Stock.ToString(); 
            FournisseurEntry.Text = piece.Fournisseur; // TODO : Prochainement picker pour fournisseur
        }
        
        //private async void LoadAppareils()
        //{
        //    AppareilPicker.ItemsSource = await Database.GetAppareilsAsync();
        //}

        private async void OnSaveClicked(object sender, EventArgs e)
        {
            // Appareil appareilPicked = AppareilPicker.SelectedItem as Appareil;

            //if (appareilPicked == null)
            //{
            //    await DisplayAlert("ERREUR", "L'appareil n'est pas un valide", "OK");
            //    return;
            //}
            
            if (double.TryParse(PrixEntry.Text, out double prix) && int.TryParse(StockEntry.Text, out int stock))
            {
                _piece.Nom = NomEntry.Text;
                _piece.Description = DescriptionEditor.Text;
                _piece.Prix = prix;
                _piece.Stock = stock;
                _piece.Fournisseur = FournisseurEntry.Text;
                await Database.UpdatePieceAsync(_piece);
                await Navigation.PopAsync();
            }
            else
            {
                await DisplayAlert("Erreur", "Veuillez vérifier les valeurs du prix et du stock.", "OK");
            }
        }

        private async void OnDeleteClicked(object sender, EventArgs e)
        {
            bool confirm = await DisplayAlert("Confirmation", "Voulez-vous vraiment supprimer cette pièce ?", "Oui", "Non");
            if (confirm)
            {
                await Database.DeletePieceAsync(_piece);
                await Navigation.PopAsync();
            }
        }
    }
}